# BackDoorBuster

![BackDoorBuster Banner](./banner.webp)

## 项目背景

随着网络安全威胁的增加，恶意软件和后门的检测成为了保护个人和组织数据安全的重要任务。后门通常被隐藏在合法软件中，给黑客提供远程控制目标系统的能力。本项目旨在开发一个工具，能够有效识别和评估潜在的后门风险。

## 项目目的

本项目的主要目的是开发一个自动化工具，用于检测和评估代码库中潜在的后门风险。通过搜索包含特定敏感操作（如直接调用 `shell`）的代码段，并对发现的结果进行评级，从而帮助安全团队识别和修复安全漏洞。

## 项目开发目标

- **敏感操作检测**: 使用正则表达式来搜索代码中可能指示后门的敏感操作，如命令行执行（例如 `bin/sh`）。
- **风险评级系统**: 对检测到的敏感操作进行分类和风险评级，帮助用户理解每个发现的潜在威胁级别。
- **简易的用户接口**: 提供一个简单的命令行接口，允许用户快速扫描项目并获取报告。
- **报告生成**: 自动生成详细的检测报告，列出所有发现的敏感操作和对应的风险等级。
- **持续更新与维护**: 随着新的后门技术和检测方法的出现，持续更新正则表达式库和评级标准。

## 打包

### pip

#### 打包命令

```bash
pip install wheel
python setup.py sdist bdist_wheel
```

执行上述命令后，会在 dist 目录下生成 .tar.gz 和 .whl 文件。

#### 本地安装

- 安装 .whl 文件：

``` bash
pip install dist/backdoor_buster-0.1.0-py3-none-any.whl
```

- 安装 .tar.gz 文件：

``` bash
pip install dist/backdoor_buster-0.1.0.tar.gz
```

#### 上传到 PyPI

- 安装 twine：

``` bash
pip install twine
```

- 使用 twine 上传包到 PyPI：

``` bash
twine upload dist/*
```

需要提供 PyPI 的用户名和密码。如果没有 PyPI 账号，可以在 PyPI 注册。

#### 使用 PyPI 安装

包上传到 PyPI 后，可以通过以下命令安装：

``` bash
pip install backdoor_buster
```

## 使用说明

1. 执行扫描:

    ```bash
    python -m detection <project_directory> -o <path> -m <mode>
    ```

2. 查看报告:

    报告将以文本形式输出在控制台，并可选择输出到指定文件。

## 贡献指南

欢迎安全研究人员和开发人员贡献代码，改进正则表达式和评级逻辑。请通过 pull requests 提交您的贡献。

## 许可证

本项目采用 `MIT` 许可证。详情请见 [LICENSE](./LICENSE) 文件。
